commit 3d12873cf648506acff66566356f469bd3a451c6
Author: jklowden <jklowden>
Date:   Mon Dec 15 05:31:13 2008 +0000

    Remove TDSSOCKET::last_packet, added tds_lastpacket().  Rename tds_connect to tds_connect_and_login.  Change tds_connect_and_login to return TDSERROR.  Remove tdserror calls from tds_open_socket.  Add tds_connect as wrapper to tds_open_socket.  Connecting with TDSVER 0.0 works without producing spurious messages.

diff --git a/ChangeLog b/ChangeLog
index 3307039..69d951e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,19 @@
+Mon Dec 15 00:15:18 EST 2008	JK Lowden <jklowden@freetds.org>
+	* include/tds.h src/apps/tsql.c
+	* src/ctlib/ct.c src/dblib/dblib.c
+	* src/odbc/odbc.c src/pool/member.c
+	* src/server/query.c src/tds/config.c
+	* src/tds/log.c src/tds/login.c
+	* src/tds/net.c src/tds/util.c
+	* src/tds/unittests/common.c
+	- Remove TDSSOCKET::last_packet, added tds_lastpacket(). 
+	- Rename tds_connect to tds_connect_and_login. 
+	- Change tds_connect_and_login to return TDSERROR. 
+	- Remove tdserror calls from tds_open_socket. 
+	- Add tds_connect as wrapper to tds_open_socket. 
+	- Connecting with TDSVER 0.0 works without producing
+	- spurious messages. 
+		
 Fri Dec 12 20:40:56 EST 2008	JK Lowden <jklowden@freetds.org>
 	* include/tds.h src/apps/tsql.c src/tds/log.c src/tds/net.c
 	- add -L to tsql to list servers using MC-SQLR CLNT_UCAST_EX. 
@@ -1044,4 +1060,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2678 2008/12/13 01:48:35 jklowden Exp $
+$Id: ChangeLog,v 1.2679 2008/12/15 05:31:13 jklowden Exp $
diff --git a/include/tds.h b/include/tds.h
index 123fe18..d882be6 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.303 2008/12/13 01:48:35 jklowden Exp $ */
+/* $Id: tds.h,v 1.304 2008/12/15 05:31:14 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -280,7 +280,8 @@ enum tds_end
  * These match the db-lib msgno, because the same values have the same meaning
  * in db-lib and ODBC.  ct-lib maps them to ct-lib numbers (todo). 
  */
-typedef enum {	TDSEICONVIU    = 2400, 
+typedef enum {	TDSEOK    = TDS_SUCCEED, 
+		TDSEICONVIU    = 2400, 
 		TDSEICONVAVAIL = 2401, 
 		TDSEICONVO     = 2402, 
 		TDSEICONVI     = 2403, 
@@ -1257,6 +1258,7 @@ typedef struct tds_multiple
 
 /* forward declaration */
 typedef struct tds_context TDSCONTEXT;
+typedef int (*err_handler_t) (const TDSCONTEXT *, TDSSOCKET *, TDSMESSAGE *);
 
 struct tds_context
 {
@@ -1292,6 +1294,7 @@ typedef struct tds_authentication TDSAUTHENTICATION;
 struct tds_socket
 {
 	TDS_SYS_SOCKET s;		/**< tcp socket, INVALID_SOCKET if not connected */
+	int oserr;
 	TDS_SMALLINT major_version;
 	TDS_SMALLINT minor_version;
 	TDS_UINT product_version;	/**< version of product (Sybase/MS and full version) */
@@ -1312,7 +1315,6 @@ struct tds_socket
 
 	unsigned char in_flag;		/**< input buffer type */
 	unsigned char out_flag;		/**< output buffer type */
-	unsigned char last_packet;	/**< true if current input buffer is the last one */
 	void *parent;
 
 	/**
@@ -1388,6 +1390,7 @@ void tds_free_context(TDSCONTEXT * locale);
 TDSSOCKET *tds_alloc_socket(TDSCONTEXT * context, int bufsize);
 
 /* config.c */
+int tds_default_port(int major, int minor);
 const TDS_COMPILETIME_SETTINGS *tds_get_compiletime_settings(void);
 typedef void (*TDSCONFPARSE) (const char *option, const char *value, void *param);
 int tds_read_conf_section(FILE * in, const char *section, TDSCONFPARSE tds_conf_parse, void *parse_param);
@@ -1395,7 +1398,7 @@ int tds_read_conf_file(TDSCONNECTION * connection, const char *server);
 void tds_parse_conf_section(const char *option, const char *value, void *param);
 TDSCONNECTION *tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale);
 void tds_fix_connection(TDSCONNECTION * connection);
-void tds_config_verstr(const char *tdsver, TDSCONNECTION * connection);
+unsigned char tds_config_verstr(const char *tdsver, TDSCONNECTION * connection);
 void tds_lookup_host(const char *servername, char *ip);
 int tds_set_interfaces_file_loc(const char *interfloc);
 extern const char STD_DATETIME_FMT[];
@@ -1462,7 +1465,7 @@ void tds_set_client_charset(TDSLOGIN * tds_login, const char *charset);
 void tds_set_language(TDSLOGIN * tds_login, const char *language);
 void tds_set_version(TDSLOGIN * tds_login, TDS_TINYINT major_ver, TDS_TINYINT minor_ver);
 void tds_set_capabilities(TDSLOGIN * tds_login, unsigned char *capabilities, int size);
-int tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection);
+int tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 
 /* query.c */
 int tds_submit_query(TDSSOCKET * tds, const char *query);
@@ -1546,6 +1549,7 @@ unsigned int tds_gettime_ms(void);
 /* log.c */
 void tdsdump_off(void);
 void tdsdump_on(void);
+int tdsdump_isopen(void);
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility pop
 #endif
@@ -1566,7 +1570,8 @@ extern int tds_debug_flags;
 extern int tds_g_append_mode;
 
 /* net.c */
-int tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout);
+int tds_lastpacket(TDSSOCKET * tds);
+TDSERRNO tds_connect(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout);
 int tds_close_socket(TDSSOCKET * tds);
 int tds_read_packet(TDSSOCKET * tds);
 int tds_write_packet(TDSSOCKET * tds, unsigned char final);
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index e1cc25b..632955b 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.123 2008/12/13 01:48:35 jklowden Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.124 2008/12/15 05:31:14 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -370,6 +370,19 @@ get_opt_flags(char *s, int *opt_flags)
 	return 1;
 }
 
+int
+get_default_instance_port(const char hostname[])
+{
+	char ip[24] = {'\0'};
+	
+	tds_lookup_host(hostname, ip);
+	
+	if (!*ip) 
+		return 0;
+	
+	return tds7_get_instance_port(ip, "MSSQLSERVER");
+}
+
 static void
 populate_login(TDSLOGIN * login, int argc, char **argv)
 {
@@ -485,17 +498,19 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 	}
 	
 	if ((global_opt_flags & OPT_INSTANCES) && hostname) {
-		static const char suffix[] = ".instances";
+		static const char template[] = "%s.instances";
+		char ip[24] = {'\0'};
 		char *filename = getenv("TDSDUMP");
+
 		if (filename) {
-			if ((filename = malloc(1+sizeof(suffix) + strlen(filename))) == NULL) 
+			if ((filename = malloc(sizeof(template) + strlen(filename))) == NULL) 
 				exit(1);
-			strcpy(filename, getenv("TDSDUMP"));
-			strcat(filename, suffix);
+			sprintf(filename, template, getenv("TDSDUMP"));
 			tdsdump_open(filename);
 			free(filename);
 		}
-		tds7_get_instance_ports(stderr, hostname); /* must be dotted-decimal ip address */
+		tds_lookup_host(hostname, ip);
+		tds7_get_instance_ports(stderr, ip);
 		tdsdump_close();
 	}
 
@@ -506,9 +521,25 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		exit(1);
 	}
 	if (hostname && !port) {
-		fprintf(stderr, "Missing argument -p \n");
-		tsql_print_usage(argv[0]);
-		exit(1);
+		/*
+		 * TODO: It would be convenient to have a function that looks up a reasonable port based on:
+		 * 	- TDSPORT environment variable
+		 * 	- config files
+		 * 	- get_default_instance_port
+		 *	- TDS version
+		 *	in that order. 
+		 */
+		if (!QUIET) {
+			printf("Missing argument -p, looking for default instance ... ", port);
+		}
+		if (0 == (port = get_default_instance_port(hostname))) {
+			printf("no reply from server\n");
+			tsql_print_usage(argv[0]);
+			exit(1);
+		} 
+		if (!QUIET)
+			printf("found default instance, port %d\n", port);
+		
 	}
 	if (!username) {
 		fprintf(stderr, "Missing argument -U \n");
@@ -682,8 +713,8 @@ main(int argc, char **argv)
 #if HAVE_FORK
 	if (connection && !QUIET) {
 		/*
-		 * Here we use a pipe so if even main program core the counter stops
-		 * Note that we do not read or write nothing from this pipe
+		 * We use a pipe so that the child is killed even main program aborts. 
+		 * Note that we do not read or write from this pipe. 
 		 */
 		if (pipe(pipes) < 0) {
 			perror("tsql: pipe");
@@ -715,7 +746,7 @@ main(int argc, char **argv)
 		close(pipes[0]);
 	}
 #endif
-	if (!connection || tds_connect(tds, connection) == TDS_FAIL) {
+	if (!connection || tds_connect_and_login(tds, connection) != TDS_SUCCEED) {
 		if( VERBOSE ) 
 			print_instance_data(connection);
 		tds_free_socket(tds);
@@ -724,12 +755,12 @@ main(int argc, char **argv)
 		fprintf(stderr, "There was a problem connecting to the server\n");
 		exit(1);
 	}
-	if( VERBOSE ) 
+	if (VERBOSE) 
 		print_instance_data(connection);
 	tds_free_connection(connection);
 	/* give the buffer an initial size */
 	bufsz = 4096;
-	mybuf = (char *) malloc(bufsz);
+	mybuf = malloc(bufsz);
 	mybuf[0] = '\0';
 	buflen = 0;
 
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index 2dcfb42..24b3bbc 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.181 2008/07/29 14:07:09 jklowden Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.182 2008/12/15 05:31:14 jklowden Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -616,7 +616,7 @@ ct_connect(CS_CONNECTION * con, CS_CHAR * servername, CS_INT snamelen)
 		*/
 	}
 
-	if (tds_connect(con->tds_socket, connection) == TDS_FAIL)
+	if (tds_connect_and_login(con->tds_socket, connection) == TDS_FAIL)
 		goto Cleanup;
 
 	tds_free_connection(connection);
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 94838ad..a1eb2ca 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.334 2008/12/11 12:37:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.335 2008/12/15 05:31:14 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1146,7 +1146,7 @@ tdsdbopen(LOGINREC * login, const char *server, int msdblib)
 
 	TDS_MUTEX_UNLOCK(&dblib_mutex);
 
-	if (tds_connect(dbproc->tds_socket, connection) == TDS_FAIL) {
+	if (tds_connect_and_login(dbproc->tds_socket, connection) == TDS_FAIL) {
 		tds_free_connection(connection);
 		dbclose(dbproc);
 		return NULL;
@@ -2714,7 +2714,10 @@ dbclrbuf(DBPROCESS * dbproc, DBINT n)
  * 
  * \param srctype type converting from
  * \param desttype type converting to
- * \remarks dbwillconvert() lies sometimes.  Some datatypes \em should be convertible but aren't yet in our implementation.   * \retval TRUE convertible, or should be. Legal unimplemented conversions return \em TRUE.  
+ * \remarks dbwillconvert() lies sometimes.  Some datatypes \em should be convertible but aren't yet in our implementation.  
+ *          Legal unimplemented conversions return \em TRUE.  
+ * \retval TRUE convertible, or should be. For conversions from a fix-length type to a character type (e.g. INT to VARCHAR), the value 
+ *         returned is the number of bytes needed hold the output.  
  * \retval FAIL not convertible.  
  * \sa dbaltbind(), dbbind(), dbconvert(), dbconvert_ps(), \c src/dblib/unittests/convert().c().
  */
@@ -4612,6 +4615,10 @@ dbsqlok(DBPROCESS * dbproc)
 
 				tdsdump_log(TDS_DBG_FUNC, "dbsqlok: returning %s with %s (%#x)\n", 
 						prdbretcode(retcode), prdbresults_state(dbproc->dbresults_state), done_flags);
+						
+				if (retcode == SUCCEED && (done_flags & TDS_DONE_MORE_RESULTS))
+					continue;
+					 
 				return retcode;
 #endif
 			default:
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index b44ce5f..3786b54 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.506 2008/12/03 08:37:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.507 2008/12/15 05:31:14 jklowden Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -381,7 +381,7 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 
 	connection->connect_timeout = dbc->attr.connection_timeout;
 
-	if (tds_connect(dbc->tds_socket, connection) == TDS_FAIL) {
+	if (tds_connect_and_login(dbc->tds_socket, connection) == TDS_FAIL) {
 		tds_free_socket(dbc->tds_socket);
 		dbc->tds_socket = NULL;
 		odbc_errs_add(&dbc->errs, "08001", NULL);
diff --git a/src/pool/member.c b/src/pool/member.c
index b82e25d..418213c 100644
--- a/src/pool/member.c
+++ b/src/pool/member.c
@@ -59,7 +59,7 @@
 #define MAXHOSTNAMELEN 256
 #endif /* MAXHOSTNAMELEN */
 
-TDS_RCSID(var, "$Id: member.c,v 1.42 2008/11/15 09:57:06 freddy77 Exp $");
+TDS_RCSID(var, "$Id: member.c,v 1.43 2008/12/15 05:31:14 jklowden Exp $");
 
 static int pool_packet_read(TDS_POOL_MEMBER * pmbr);
 static TDSSOCKET *pool_mbr_login(TDS_POOL * pool);
@@ -96,7 +96,7 @@ pool_mbr_login(TDS_POOL * pool)
 	context = tds_alloc_context(NULL);
 	tds = tds_alloc_socket(context, 512);
 	connection = tds_read_config_info(NULL, login, context->locale);
-	if (!connection || tds_connect(tds, connection) == TDS_FAIL) {
+	if (!connection || tds_connect_and_login(tds, connection) == TDS_FAIL) {
 		tds_free_socket(tds);
 		tds_free_connection(connection);
 		/* what to do? */
@@ -105,7 +105,7 @@ pool_mbr_login(TDS_POOL * pool)
 	}
 	tds_free_connection(connection);
 	/*
-	 * FIXME -- tds_connect no longer preallocates the in_buf need to 
+	 * FIXME -- tds_connect_and_login no longer preallocates the in_buf need to 
 	 * do something like what tds_read_packet does
 	 */
 	tds->in_buf = (unsigned char *) malloc(BLOCKSIZ);
diff --git a/src/server/query.c b/src/server/query.c
index 8ebd212..adf16e6 100644
--- a/src/server/query.c
+++ b/src/server/query.c
@@ -29,7 +29,7 @@
 #include "tds.h"
 #include "tdssrv.h"
 
-static char software_version[] = "$Id: query.c,v 1.17 2007/09/24 10:02:14 freddy77 Exp $";
+static char software_version[] = "$Id: query.c,v 1.18 2008/12/15 05:31:14 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char *query;
@@ -138,7 +138,7 @@ char *tds_get_generic_query(TDSSOCKET * tds)
 				/* TODO: WE DON'T HANDLE PARAMETERS YET! */
 
 				/* eat the rest of the packet */
-				while (!tds->last_packet && tds_read_packet(tds) > 0) {
+				while (!tds_lastpacket(tds) && tds_read_packet(tds) > 0) {
 				}
 				return query;
 
@@ -146,7 +146,7 @@ char *tds_get_generic_query(TDSSOCKET * tds)
 				/* unexpected token */
 
 				/* eat the rest of the packet */
-				while (!tds->last_packet && tds_read_packet(tds) > 0) {
+				while (!tds_lastpacket(tds) && tds_read_packet(tds) > 0) {
 				}
 				return NULL;
 			}
@@ -181,7 +181,7 @@ char *tds_get_generic_query(TDSSOCKET * tds)
 				}
 
 				/* if more then read it */
-				if (tds->last_packet)
+				if (tds_lastpacket(tds))
 					break;
 				if (tds_read_packet(tds) < 0)
 					return NULL;
diff --git a/src/tds/config.c b/src/tds/config.c
index 220c253..5863e9f 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.138 2008/12/10 14:56:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.139 2008/12/15 05:31:15 jklowden Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -110,6 +110,19 @@ static const char pid_logpath[] = "c:\\freetds.log.%d";
 static const char interfaces_path[] = "c:\\";
 #endif
 
+int
+tds_default_port(int major, int minor)
+{
+	switch(major) {
+	case 4:
+		if (minor == 6)
+			break;
+	case 5:
+		return 4000;
+	}
+	return 1433;
+}
+
 /**
  * \ingroup libtds
  * \defgroup config Configuration
@@ -675,41 +688,43 @@ tds_config_env_tdshost(TDSCONNECTION * connection)
  * Set TDS version from given string
  * @param tdsver tds string version
  * @param connection where to store information
+ * @return as encoded hex value: high nybble major, low nybble minor.  
  */
-void
+unsigned char
 tds_config_verstr(const char *tdsver, TDSCONNECTION * connection)
 {
+	TDSCONNECTION dummy, *c = &dummy;
+	
+	if (connection) 
+		c = connection;
+	
 	if (!strcmp(tdsver, "42") || !strcmp(tdsver, "4.2")) {
-		connection->major_version = 4;
-		connection->minor_version = 2;
-		return;
+		c->major_version = 4;
+		c->minor_version = 2;
 	} else if (!strcmp(tdsver, "46") || !strcmp(tdsver, "4.6")) {
-		connection->major_version = 4;
-		connection->minor_version = 6;
-		return;
+		c->major_version = 4;
+		c->minor_version = 6;
 	} else if (!strcmp(tdsver, "50") || !strcmp(tdsver, "5.0")) {
-		connection->major_version = 5;
-		connection->minor_version = 0;
-		return;
+		c->major_version = 5;
+		c->minor_version = 0;
 	} else if (!strcmp(tdsver, "70") || !strcmp(tdsver, "7.0")) {
-		connection->major_version = 7;
-		connection->minor_version = 0;
-		return;
+		c->major_version = 7;
+		c->minor_version = 0;
 	} else if (!strcmp(tdsver, "80") || !strcmp(tdsver, "8.0")) {
-		connection->major_version = 8;
-		connection->minor_version = 0;
-		return;
+		c->major_version = 8;
+		c->minor_version = 0;
 #ifdef ENABLE_DEVELOPING
 	} else if (!strcmp(tdsver, "90") || !strcmp(tdsver, "9.0")) {
-		connection->major_version = 9;
-		connection->minor_version = 0;
-		return;
+		c->major_version = 9;
+		c->minor_version = 0;
 #endif
 	} else if (!strcmp(tdsver, "0.0")) {
-		connection->major_version = 0;
-		connection->minor_version = 0;
-		return;
-	}
+		c->major_version = 0;
+		c->minor_version = 0;
+	} else 
+		return 0;
+	
+	return (c->major_version << 4) | c->minor_version;
 }
 
 /**
@@ -778,7 +793,7 @@ tds_lookup_host(const char *servername,	/* (I) name of the server
 /**
  * Given a portname lookup the port.
  *
- * If we can't determine the port number than function return 0.
+ * If we can't determine the port number then return 0.
  */
 static int
 tds_lookup_port(const char *portname)
@@ -945,7 +960,7 @@ search_interface_file(TDSCONNECTION * connection, const char *dir, const char *f
 static void
 tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 {
-	int founded = 0;
+	int found = 0;
 
 	/* read $SYBASE/interfaces */
 
@@ -964,18 +979,18 @@ tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 	 */
 	if (interf_file) {
 		tdsdump_log(TDS_DBG_INFO1, "Looking for server in file %s.\n", interf_file);
-		founded = search_interface_file(connection, "", interf_file, server);
+		found = search_interface_file(connection, "", interf_file, server);
 	}
 
 	/*
 	 * if we haven't found the server yet then look for a $HOME/.interfaces file
 	 */
-	if (!founded) {
+	if (!found) {
 		char *path = tds_get_home_file(".interfaces");
 
 		if (path) {
 			tdsdump_log(TDS_DBG_INFO1, "Looking for server in %s.\n", path);
-			founded = search_interface_file(connection, "", path, server);
+			found = search_interface_file(connection, "", path, server);
 			free(path);
 		}
 	}
@@ -983,7 +998,7 @@ tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 	/*
 	 * if we haven't found the server yet then look in $SYBBASE/interfaces file
 	 */
-	if (!founded) {
+	if (!found) {
 		const char *sybase = getenv("SYBASE");
 #ifdef __VMS
 		/* We've got to be in unix syntax for later slash-joined concatenation. */
@@ -995,14 +1010,14 @@ tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 			sybase = interfaces_path;
 
 		tdsdump_log(TDS_DBG_INFO1, "Looking for server in %s/interfaces.\n", sybase);
-		founded = search_interface_file(connection, sybase, "interfaces", server);
+		found = search_interface_file(connection, sybase, "interfaces", server);
 	}
 
 	/*
 	 * If we still don't have the server and port then assume the user
 	 * typed an actual server name.
 	 */
-	if (!founded) {
+	if (!found) {
 		char ip_addr[255];
 		int ip_port;
 		const char *env_port;
diff --git a/src/tds/log.c b/src/tds/log.c
index abbbf05..4beb990 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,7 +66,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.9 2008/12/13 01:48:35 jklowden Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.10 2008/12/15 05:31:15 jklowden Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
@@ -107,7 +107,13 @@ tdsdump_on(void)
 	TDS_MUTEX_LOCK(&g_dump_mutex);
 	write_dump = 1;
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
-}				/* tdsdump_on()  */
+}
+
+int
+tdsdump_isopen()
+{
+	return NULL != g_dumpfile;
+}
 
 
 /**
diff --git a/src/tds/login.c b/src/tds/login.c
index 1c12428..984ed12 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.176 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.177 2008/12/15 05:31:15 jklowden Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -306,12 +306,18 @@ free_save_context(TDSSAVECONTEXT *ctx)
  * Do a connection to socket
  * @param tds connection structure. This should be a non-connected connection.
  * @param connection info for connection
- * @return TDS_FAIL or TDS_SUCCEED
+ * @return TDS_FAIL or TDS_SUCCEED if a connection was made to the server's port.
+ * @return TDSERROR enumerated type if no TCP/IP connection could be formed. 
+ * @remark Possible error conditions:
+ *		- TDSESOCK: socket(2) failed: insufficient local resources
+ * 		- TDSECONN: connect(2) failed: invalid hostname or port (ETIMEDOUT, ECONNREFUSED, ENETUNREACH)
+ * 		- TDSEFCON: connect(2) succeeded, login packet not acknowledged.  
+ *		- TDS_FAIL: connect(2) succeeded, login failed.  
  */
 int
-tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection)
+tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 {
-	int retval;
+	int erc;
 	int connect_timeout = 0;
 	int db_selected = 0;
 
@@ -335,32 +341,45 @@ tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection)
 		const TDSCONTEXT *old_ctx = tds->tds_ctx;
 		typedef void (*env_chg_func_t) (TDSSOCKET * tds, int type, char *oldval, char *newval);
 		env_chg_func_t old_env_chg = tds->env_chg_func;
+		/* the context of a socket is const; we have to modify it to suppress error messages during multiple tries. */
+		TDSCONTEXT *mod_ctx = (TDSCONTEXT *)tds->tds_ctx;
+		err_handler_t err_handler = tds->tds_ctx->err_handler;
 
 		init_save_context(&save_ctx, old_ctx);
 		tds->tds_ctx = &save_ctx.ctx;
 		tds->env_chg_func = tds_save_env;
+		mod_ctx->err_handler = NULL;
+
 		for (i=0; i < TDS_VECTOR_SIZE(versions); ++i) {
 			connection->major_version = versions[i].major_version;
 			connection->minor_version = versions[i].minor_version;
-			/* fprintf(stdout, "trying TDSVER %d.%d\n", connection->major_version, connection->minor_version); */
 			reset_save_context(&save_ctx);
-			retval = tds_connect(tds, connection);
-			if (TDS_SUCCEED == retval)
+
+			if ((erc = tds_connect_and_login(tds, connection)) == TDS_FAIL) {
+				tds_close_socket(tds);
+			}
+			
+			if (erc != TDSEFCON)	/* TDSEFCON indicates wrong TDS version */
 				break;
-			tds_close_socket(tds);
 		}
+		
+		mod_ctx->err_handler = err_handler;
 		tds->env_chg_func = old_env_chg;
 		tds->tds_ctx = old_ctx;
 		replay_save_context(tds, &save_ctx);
 		free_save_context(&save_ctx);
-		return retval;
+		
+		if (erc != TDS_SUCCEED)
+			tdserror(tds->tds_ctx, tds, erc, tds->oserr); 
+
+		return erc;
 	}
 	
 
 	/*
 	 * If a dump file has been specified, start logging
 	 */
-	if (!tds_dstr_isempty(&connection->dump_file)) {
+	if (!tds_dstr_isempty(&connection->dump_file) && !tdsdump_isopen()) {
 		if (connection->debug_flags)
 			tds_debug_flags = connection->debug_flags;
 		tdsdump_open(tds_dstr_cstr(&connection->dump_file));
@@ -405,7 +424,7 @@ tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection)
 		} else {
 			tdsdump_log(TDS_DBG_ERROR, "No server specified!\n");
 		}
-		return TDS_FAIL;
+		return TDSECONN;
 	}
 
 	if (!IS_TDS50(tds) && !tds_dstr_isempty(&connection->instance_name))
@@ -413,30 +432,37 @@ tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection)
 
 	if (connection->port < 1) {
 		tdsdump_log(TDS_DBG_ERROR, "invalid port number\n");
-		return TDS_FAIL;
+		return TDSECONN;
 	}
 
 	memcpy(tds->capabilities, connection->capabilities, TDS_MAX_CAPABILITY);
 
-	if (tds_open_socket(tds, tds_dstr_cstr(&connection->ip_addr), connection->port, connect_timeout) != TDS_SUCCEED)
-		return TDS_FAIL;
+	if ((erc = tds_connect(tds, tds_dstr_cstr(&connection->ip_addr), connection->port, connect_timeout)) != TDS_SUCCEED)
+		return erc;
+		
+	/*
+	 * Beyond this point, we're connected to the server.  We know we have a valid TCP/IP address+socket pair.  
+	 * Although network errors *might* happen, most problems from here on out will be TDS-level errors, 
+	 * either TDS version problems or authentication problems.  
+	 */
+		
 	tds_set_state(tds, TDS_IDLE);
 
 	if (IS_TDS8_PLUS(tds)) {
-		retval = tds8_do_login(tds, connection);
+		erc = tds8_do_login(tds, connection);
 		db_selected = 1;
 	} else if (IS_TDS7_PLUS(tds)) {
-		retval = tds7_send_login(tds, connection);
+		erc = tds7_send_login(tds, connection);
 		db_selected = 1;
 	} else {
 		tds->out_flag = TDS_LOGIN;
-		retval = tds_send_login(tds, connection);
+		erc = tds_send_login(tds, connection);
 	}
-	if (retval == TDS_FAIL || !tds_process_login_tokens(tds)) {
+	if (erc == TDS_FAIL || !tds_process_login_tokens(tds)) {
+		tdsdump_log(TDS_DBG_ERROR, "login packet %s\n", erc==TDS_SUCCEED? "accepted":"rejected");
 		tds_close_socket(tds);
 		tdserror(tds->tds_ctx, tds, TDSEFCON, 0); 	/* "Adaptive Server connection failed" */
-								/* If it's a bad login, the server will send that mesasge */
-		return TDS_FAIL;
+		return TDSEFCON;
 	}
 
 	if (connection->text_size || (!db_selected && !tds_dstr_isempty(&connection->database))) {
@@ -455,9 +481,9 @@ tds_connect(TDSSOCKET * tds, TDSCONNECTION * connection)
 			strcat(str, "use ");
 			tds_quote_id(tds, strchr(str, 0), tds_dstr_cstr(&connection->database), -1);
 		}
-		retval = tds_submit_query(tds, str);
+		erc = tds_submit_query(tds, str);
 		free(str);
-		if (retval != TDS_SUCCEED)
+		if (erc != TDS_SUCCEED)
 			return TDS_FAIL;
 
 		if (tds_process_simple_query(tds) != TDS_SUCCEED)
